{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
(**
 ** EMPATHY Textmode Screen Editor, plus viewer, version 1.00p !
 ** The EMPATHY Experience - A Grant Passmore / Avenge Cult / ACiD Production
 ** Copyright Grant Passmore (Skaboy) & ACiD Productions, LLC 1998-2003
 ** Released under the terms of the GNU General Public License (GPL)

    EMPATHY is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (GPL.TXT); if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

 ** EMPATHY history log
 ** 1998-Jul-28: Began code from scratch
 ** 1999-Jan-01: First full public release
 ** 1999-Aug-30: First public introduction of code as openSource
 ** 2002-Sep-04: Code re-opened in preparation for release in the
                 final artpack, ACiD-100 !
 ** 2003-Nov-08: Published 1.00a code for internal review
 ** 2003-Dec-20: Finalized 1.00p code for public release

 ** Skaboy/Grant Passmore<acid,avenge,xorbex international>
 ** Scout You Devil/avenge productions/acid productions
 ** http://www.scoutyoudevil.com | http://www.acid.org
 ** skaboy@mail.acid.org

 ** LICENSE: I Release this code under the GNU General Public License.
             It is free for anyone and everyone to use for learning
             and helping the scene.  Always do good things.

             Always willing to help you with questions,
             -Grant Olney Passmore
             moment@cs.utexas.edu
             http://www.grantolney.com/
 **)

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

{$M 64000,45000,200000}
program empathy;
 uses crt,dos,control,skaunit,genshit,xms_,records,loadFile,extense,config,
      avga,SaveFile,little,timeunit,blckshit,emouse,helpshit,resman;

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

const
{$I eKeys.inc}
{$I date.inc}

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eGoPos; Forward;
Procedure eUpdateScreen; Forward;
Procedure eDoDelete; Forward;
Procedure eDoAttributeSelection(fill : byte); Forward;
Procedure eDragAttribute; Forward;
Procedure eAttribScrn;    External; {$L .\ART\ATTRIB.OBJ}
Procedure eQuickPal;      External; {$L .\ART\QUICKPAL.OBJ}
Procedure eOpenScrn;      External; {$L .\ART\NEWTITLE.OBJ}
Procedure eOpenScrnFont;  External; {$L .\ART\NEWTITFO.OBJ}
Procedure eOpenScrnPal;   External; {$L .\ART\NEWTITPA.OBJ}
Procedure eExitScrn;      External; {$L .\ART\EXITSCRN.OBJ}
Procedure eHelpScrnPal;   External; {$L .\ART\HELPPAL.OBJ}
Procedure eHelpScrnFont;  External; {$L .\ART\HELPFONT.OBJ}
Procedure eHelpScrnImage; External; {$L .\ART\HELPIMG.OBJ}
Procedure e8x8FontData;   External; {$L .\ART\8X8FONT.OBJ}
Procedure eAmigaFontData; External; {$L .\ART\AMIGA.OBJ}

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eInitConfig;
var
  eF : file;
   x : byte;
begin
  assign(eF,'empathy.dat');
  rewrite(eF,1);
  fillChar(eConfigData^,sizeOf(eConfigData^),0);
  eConfigData^.cValidNum  := 'EMP00';
  eConfigData^.cDelete    := true;
  eConfigData^.cDosShell  := true;
  eConfigData^.cQuit      := true;
  eConfigData^.cClear     := true;
  eConfigData^.cRestore   := true;
  eConfigData^.cOvrWrite  := true;
  eConfigData^.cIntro     := true;
  eConfigData^.cSauce     := 1;      { Always / Ask / Never }
  eConfigData^.cVgaMode   := 0;
  eConfigData^.cWidth     := 80;
  eConfigData^.c8x16Mode  := true;
  eConfigData^.cStartFg   := 7;
  eConfigData^.cStartBg   := 0;
  eConfigData^.cDefAuthor := 'Author';
  eConfigData^.cDefGroup  := 'ACiD Productions';
  eConfigData^.cAnsiExt   := 'ANS';
  eConfigData^.cAsciiExt  := 'ASC';
  eConfigData^.cAdfExt    := 'ADF';
  eConfigData^.cBinExt    := 'BIN';
  eConfigData^.cXBinExt   := 'XB';
  eConfigData^.cPalExt    := 'PAL';
  eConfigData^.cFontExt   := 'FNT';
  eConfigData^.cPascalExt := 'INC';
  eConfigData^.cCppExt    := 'H';
  eConfigData^.cPipExt    := 'PIP';
  eConfigData^.cAskSave   := true;
  eConfigData^.cPages     := 9;
  eConfigData^.cAlphaList := true;
  for x := 1 to 80 do if (x mod 8=0) then eConfigData^.cTabLen[x] := true;
  eInitDefaultChars;
  blockWrite(eF,eConfigData^,sizeOf(eConfigData^));
  close(eF);
end;

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eCheckConfig;
 var eF : file;
      c : char;
 begin
 clrScr;
 if not exist('empathy.dat') then eInitConfig else
 begin
  assign(eF,'empathy.dat');
  reset(eF,1);
  if (fileSize(eF)<>sizeOf(eConfigData^)) then
   begin
   close(eF);
   eInitConfig;
   assign(eF,'empathy.dat');
   reset(eF,1);
   blockRead(eF,eConfigData^,sizeOf(eConfigData^));
   end else blockRead(eF,eConfigData^,sizeOf(eConfigData^));
   close(eF);
  end;
 end;

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eReInitTime;
Begin
  eCurrentData^.CurTime.eStarted := True;
  eCurrentData^.CurTime.ePaused  := False;
  eCurrentData^.CurTime.eStart   := eReadTimer;
  eCurrentData^.CurTime.eStopped := eReadTimer;
  eCurrentData^.CurTime.eSeconds := 0;
  eCurrentData^.CurTime.eMinutes := 0;
  eCurrentData^.CurTime.eHours   := 0;
End;

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eUpdateTimer;
var eTotalSeconds : real;
 begin
 eCurrentData^.curTime.eStopped := eReadTimer;
 eTotalSeconds := (eElapsedTime(eCurrentData^.curTime.eStart,eCurrentData^.curTime.eStopped) / 1000);
 if (eTotalSeconds>60*60) then
  begin
   eCurrentData^.curTime.eHours   := round(eTotalSeconds / (60*60));
   eCurrentData^.curTime.eMinutes := round(round(eTotalSeconds) mod round(eCurrentData^.curTime.eHours)+1);
   eCurrentData^.curTime.eSeconds := (eTotalSeconds-(eCurrentData^.curTime.eHours*60*60)+(eCurrentData^.curTime.eMinutes*60));
  end else if (eTotalSeconds>60) then
   begin
    eCurrentData^.curTime.eHours   := 0;
    if (((eTotalSeconds / 60)-round(eTotalSeconds / 60))<0) then
          eCurrentData^.curTime.eMinutes := round(eTotalSeconds / 60)-1 else
          eCurrentData^.curTime.eMinutes := round(eTotalSeconds);
    eCurrentData^.curTime.eSeconds := (eTotalSeconds-(eCurrentData^.curTime.eMinutes*60));
   end else if (eTotalSeconds>0) then
    begin
     eCurrentData^.curTime.eHours   := 0;
     eCurrentData^.curTime.eMinutes := 0;
     eCurrentData^.curTime.eSeconds := eTotalSeconds;
    end;
 end;

{::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eShowStatusBar(sLevel : byte);

   Procedure eShowPos;
   begin
   gotoxy(1,1);
   skaWrite('|B0|08(|03'+eTabWord(eCurrentData^.curReal[1],3)+'|07, |03'+eTabWord(eCurrentData^.curReal[2],5)+'|08)');
   if (eCurrentData^.curHidden=true) then skaWrite('|B0|03*') else skaWrite('|B0 ');
   end;

   Procedure eShowColor;
   begin
   if (eCurrentData^.curDragOn=true) then
    begin
    textAttr := eCurrentData^.curColor;
    gotoXY(14,1); skaWrite(' DragAtr ')
    end else
     begin
     if (eCurrentData^.curColor>0) then
      begin
      textAttr := eCurrentData^.curColor;
      gotoxy(14,1); skaWrite('  Color  ');
      end else
       begin
       textAttr := 8;
       gotoXY(14,1); skaWrite('  Hidden  ');
      end;
    end;
   end;

   Procedure eShowOvrMode;
   begin
   gotoxy(24,1); if not eCurrentData^.curInsert then skaWrite('|B0|11Ov|03r') else
   skaWrite('|B0|11In|03s');
   end;

   Procedure eShowPage;
   var ePercent : byte;
   begin
   gotoXY(29,1); skaWrite('|B0|03Pa|11ge:'+strr(eCurrentData^.curPage));
   end;

   Procedure eShowSet;
   var eDummy : byte;
   begin
   gotoxy(36,1); skaWrite('|B0|08');
   for eDummy := 1 to 10 do
     begin
     skaWrite('|B7|08 '+strr(eDummy)+':|15'+eCurrentSet[eDummy]);
      if (eDummy = 10) then
          begin write(#32); skaWrite('|B0|08');end;
     end;
   end;

  begin
  window(1,1,80,eBotPos[eCurrentData^.curRes]+1);
  cursor_off;
  blinking(false);
  case sLevel of
   1 : eShowPos;
   2 : eShowColor;
   3 : eShowOvrMode;
   4 : eShowPage;
   5 : eShowSet;
   6 : begin
       textAttr := 7;clrEol;eShowPos;eShowColor;eShowOvrMode;eShowPage;eShowSet;
       end;
  end;
 window(1,2,80,eBotPos[eCurrentData^.curRes]+1);
 cursor_on;
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDrawScreens(dScrn : byte);
var x : word;
 eBuf : array[0..3999] of byte;
 begin
  if (dScrn=0) then
    begin
    asm mov ax, 03h; int 10h; end;
    textAttr := 7;
    cursor_off;
    clrscr;
    eDefaultAdfData;
    move(@eOpenScrnPal^,eCurrentData^.curPal,192);
    move(@eOpenScrnFont^,eCurrentData^.curFont,4096);
    eSetAdfAll;
    Blinking(false);
    Set8x16Font;
    for x := 25 downto 0 do
     begin
     move(@eOpenScrn^,mem[$b800:x*160],4000);
     waitRetrace;
     port[$3D4] := $08;
     port[$3D5] := (port[$3D5] and $E0) or (x and $E0);
     end;
    asm sti end;
   { randomize;
    gotoxy(24,2); skaWrite('|07another beautiful |15ac|07i|15d|07 production');
    center_write(eCaption[random(9)],23);}
    textAttr := 2*16+3;
    gotoXY(12,8); write('1.00');
    end else
  if (dScrn=1) then
    begin
    clrscr;
    eUpdateScreen;
    eShowStatusBar(6);
    end else
  if (dScrn=2) then
    begin
    window(1,1,80,25);
    asm mov ax, 3; int 10h end;
    move(@eExitScrn^,mem[$b800:0],21*160);

    TextAttr := 15;
    GotoXY (6, 2);
    SkaWrite ('Empathy v' + eVersion + ':ACiD #100');
    GotoXY (6, 3);
    SkaWrite ('Copyright (C) Grant Passmore aka Skaboy');

    TextAttr := 7;
    GotoXY (16, 21);
    skaWrite('Additional Programming By |15g00r00 |07for AC|15i|07D |08#|15100|07.');

(*
    textAttr := 15; { gotoXY(65,18);  }
    write('Empathy Experience v'+eVersion+' - (c)Copyright Grant Passmore / '+
                                                'ACiD 1998-2003');
    textAttr := 7;
    writeLn('   Released freeware for all.  Always do good things.  skaboy@mail.acid.org    ');
    cursor_on; { gotoXY(1,22); }
    textAttr := 7;
{    writeLn('Time spent drawing: ',round(eCurrentData^.curTime.eHours),
            'h ',round(eCurrentData^.curTime.eMinutes),'m ',eCurrentData^.curTime.eSeconds,'s.');}
{    writeLn('Frames for eCreate Drawing Movie beta: ',eCurrentData^.curChanges+2,' with compressed palette.'#13#10#13#10);}
*)
    gotoXY(1,22);
    halt(5);
    end else
  if (dScrn=3) then
    begin
    clrscr;
    skaWrite('|CR|CR|08'#254'|07 Empathy requires an XMS Driver to run.|CR');
    skaWrite('|08'#254'|07 Empathy has attempted to revert to available XMS but it could not be allocated.|CR');
    skaWrite('|07  Please email skaboy@mail.acid.org about this problem on your machine.|CR');
    halt(5);
    end else
  if (dScrn=4) then
    begin
    skaWrite('|CR|07The Empathy Experience, (c)Copyright Grant Passmore (skaboy) / Avenge / ACiD 1998-2003|CR');
    skaWrite('|08-|07-------------------------------------------------------------------------------');
    skaWrite('|08'#254'- |07 Valid Empathy parameters are as follows: |CR|CR');
    skaWrite('|08'#254'- |08 /Small    |07%- this command has been phased out!|CR');
    skaWrite('|08'#254'- |15 /L <file> |07%- loadfile into empathy from start-up|CR');
    skaWrite('|08'#254'- |15 /?        |07%- this help screen|CR|07');
    halt(5);
    end else
  if (dScrn=5) then
    begin
    skaWrite('|CR|07The Empathy Experience, (c)Copyright Grant Passmore (skaboy) / Avenge / ACiD 1998-2003|CR');
    skaWrite('|08%|07 error, this version of empathy is |08n|07o|15t|07 for you, chump!|CR');
    skaWrite('|08%|07 please contact Grant Passmore (skaboy@mail.acid.org) if you would like a testing license..|CR');
    skaWrite('|08%|07 if this is a licensed copy, then please make sure that |15empathy.key|07 is in the|CR');
    skaWrite('  |07present directory.|CR');
    end;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eShowRuler;
var eCount   : byte;
    eTmpChar : char;
    eTmpStr  : string;
 begin
 eUpdateScreen;
 cursor_off;
 fillChar(eTmpStr,sizeOf(eTmpStr),0);
 for eCount := 1 to eBotPos[eCurrentData^.curRes] do
  begin
   case eCount of
    1,11,21,31,41 : eTmpChar := chr((eCount div 10)+48);
    6,16,26,36,46 : eTmpChar := '+';
    else eTmpChar := '|';
   end;
  eTmpStr := eTmpStr + eTmpChar;
  end;
 skaVertFastWrite(eCurrentData^.curPos[1],2,eTmpStr,8,7);
 fillChar(eTmpStr,sizeOf(eTmpStr),0);
 for eCount := 1 to 80 do
  begin
   case eCount of
    1,11,21,31,41,51,61,71 : eTmpChar := chr((eCount div 10)+48);
    6,16,26,36,46,56,66,76 : eTmpChar := '+';
     else eTmpChar := '-';
   end;
   eTmpStr := eTmpStr + eTmpChar;
  end;
 skaFastWrite(1,eCurrentData^.curPos[2]+1,eTmpStr,8,7);
 skaFastWrite(eCurrentData^.curPos[1],eCurrentData^.curPos[2]+1,#4,0,7);
 cursor_on; gotoxy(eCurrentData^.curPos[1],eCurrentData^.curPos[2]);
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eGoPos;
var tmp : byte;
    tmp2: byte;
 begin
 textAttr := 15;
 if (eCurrentData^.curReal[1]<1) then eCurrentData^.curReal[1] := 1;
 if (eCurrentData^.curReal[2]<1) then eCurrentData^.curReal[2] := 1;
 gotoxy(eCurrentData^.curPos[1],eCurrentData^.curPos[2]);
 if (eCurrentData^.curRulerOn=true) then eShowRuler;
 if (eCurrentData^.curDragOn=true) then eDragAttribute;
 if (eCurrentData^.curInsert=true) then eSetupCursor(0,15) else
     eSetupCursor(14,15);
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eUpdateScreen;
var x : longInt;
 begin
 for x := eCurrentData^.curStart to eCurrentData^.curStart+(eBotPos[eCurrentData^.curRes]-1) do
   eShowLine(x,x-eCurrentData^.curStart+1);
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eRemoveData;
 begin
 eScrnPtr := (((eCurrentData^.curReal[2]-1)*eConfigData^.cWidth)*2)+((eCurrentData^.curReal[1]-1)*2);
 if (eCurrentData^.curInsert=false) or (eCurrentData^.curReal[1]=1) then
     xmsMoveDataTo(eXmsHandle,eScrnPtr,2,@eNull) else
  begin
  eDoDelete;
  end;
 eShowLine(eCurrentData^.curReal[2],eCurrentData^.curPos[2]);
 eShowStatusBar(1);
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eAddData(aChar : char);
var eTmpWord : word;
    eTmpBuff : array[0..(999*2)] of byte;
    eCount   : word;
 begin
 inc(eCurrentData^.curChanges);
 eTmpWord := word(aChar)+word(eCurrentData^.curColor shl 8);
 if (eCurrentData^.curReal[2]>eCurrentData^.curLength) then
     eCurrentData^.curLength := eCurrentData^.curReal[2];
 if (eCurrentData^.curInsert=false) then
  begin
  eScrnPtr := (((eCurrentData^.curReal[2]-1)*eConfigData^.cWidth)*2)+((eCurrentData^.curReal[1]-1)*2);
  xmsMoveDataTo(eXmsHandle,eScrnPtr,2,@eTmpWord);
  end else
   begin
   fillChar(eTmpBuff,sizeOf(eTmpBuff),0);
   eScrnPtr := eConfigData^.cWidth*(eCurrentData^.curReal[2]-1)*2;
   xmsGetDataFrom(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTmpBuff);
   for eCount := (eConfigData^.cWidth*2) downto ((eCurrentData^.curReal[1]-1)*2) do
     eTmpBuff[eCount] := eTmpBuff[eCount-2];
   eTmpBuff[(eCurrentData^.curReal[1]-1)*2]     := ord(aChar);
   eTmpBuff[((eCurrentData^.curReal[1]-1)*2)+1] := eCurrentData^.curColor;
   xmsMoveDataTo(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTmpBuff);
   end;
 eShowLine(eCurrentData^.curReal[2],eCurrentData^.curPos[2]);
 if (eCurrentData^.curPos[1]<>80) then
  begin
  inc(eCurrentData^.curPos[1]);
  inc(eCurrentData^.curReal[1]);
  end else
 if (eCurrentData^.curReal[1]<>eConfigData^.cWidth) then
  begin
  inc(eCurrentData^.curReal[1]);
  inc(eCurrentData^.curColStart);
  if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
  end;
 eGoPos;
 eShowStatusBar(1);
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoColumnInsert(insert : boolean);
var eTemp  : array[0..999*2] of byte;
    eCount : array[1..2] of longInt;
 begin
 window(1,1,80,eBotPos[eCurrentData^.curRes]+1);
 cursor_off;
 gotoxy(1,1);textAttr := 7;clrEol;
 skawrite('|15D|07o |15y|07ou |15r|07eally |15w|07ant |15t|07o ');
 if insert then skaWrite('|03insert |07a |15n|07ew |15c|07olumn |15h|07ere? ')
     else skaWrite('|03delete |15c|07olumn |03'+strr(eCurrentData^.curReal[1])+'|07? ');
 if (eSel=true) then begin
 if ((insert=true) and (eCurrentData^.curReal[1]<>eConfigData^.cWidth)) then
  begin
  inc(eCurrentData^.curChanges,1);
  for eCount[1] := 1 to eCurrentData^.curLength do
   begin
   fillChar(eTemp,sizeOf(eTemp),0);
   xmsGetDataFrom(eXmsHandle,pred(eCount[1])*eConfigData^.cWidth*2,eConfigData^.cWidth*2,@eTemp);
   for eCount[2] := (eConfigData^.cWidth*2) downTo (pred(eCurrentData^.curReal[1])*2) do
    eTemp[eCount[2]] := eTemp[eCount[2]-2];
   eTemp[pred(eCurrentData^.curReal[1])*2]     := 32;
   eTemp[(pred(eCurrentData^.curReal[1])*2)+1] := 7;
   xmsMoveDataTo(eXmsHandle,pred(eCount[1])*eConfigData^.cWidth*2,eConfigData^.cWidth*2,@eTemp);
   end;
  end else if ((insert=false) and (eCurrentData^.curReal[1]<>eConfigData^.cWidth)) then
   begin
   for eCount[1] := 1 to eCurrentData^.curLength do
    begin
    fillChar(eTemp,sizeOf(eTemp),0);
    xmsGetDataFrom(eXmsHandle,pred(eCount[1])*eConfigData^.cWidth*2,eConfigData^.cWidth*2,@eTemp);
    for eCount[2] := (pred(eCurrentData^.curReal[1])*2) to (eConfigData^.cWidth*3) do
     eTemp[eCount[2]] := eTemp[eCount[2]+2];
    xmsMoveDataTo(eXmsHandle,pred(eCount[1])*eConfigData^.cWidth*2,eConfigData^.cWidth*2,@eTemp);
    end;
   end;
  end;
 eShowStatusBar(6);
 eUpdateScreen;
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoLineInsert(insert : boolean);
var eTemp  : array[0..999*2] of byte;
    eCount : longInt;
 begin
 inc(eCurrentData^.curChanges);
 if (insert=true) and (eCurrentData^.curReal[2]<>eMaxLines) then
  begin
  if (eCurrentData^.curReal[2]<=eCurrentData^.curLength) then
   begin
   inc(eCurrentData^.curLength);
   for eCount := eCurrentData^.curLength downto eCurrentData^.curReal[2] do
    begin
    eScrnPtr := ((pred(eCount)*eConfigData^.cWidth)*2);
    xmsGetDataFrom(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTemp);
    eScrnPtr := (eCount*eConfigData^.cWidth*2);
    xmsMoveDataTo(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTemp);
    end;
   eScrnPtr := ((pred(eCurrentData^.curReal[2])*eConfigData^.cWidth)*2);
   for eCount := 0 to (999*2) do if (odd(eCount)=true) then eTemp[eCount] := 7 else
       eTemp[eCount] := 32;
   xmsMoveDataTo(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTemp);
   end;
  end else if (insert=false) and (eCurrentData^.curReal[2]<>eMaxLines) then
   begin
   if (eCurrentData^.curReal[2]<=eCurrentData^.curLength) then
    begin
    dec(eCurrentData^.curLength);
    for eCount := eCurrentData^.curReal[2] to eCurrentData^.curLength+1 do
     begin
     eScrnPtr := (eCount*eConfigData^.cWidth*2);
     xmsGetDataFrom(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTemp);
     eScrnPtr := (pred(eCount)*eConfigData^.cWidth*2);
     xmsMoveDataTo(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTemp);
     end;
    end;
   end;
 if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoDelete;
var eTemp  : array[0..999*2] of byte;
    eCount : word;
 begin
 inc(eCurrentData^.curChanges);
 for eCount := 0 to (999*2) do if (odd(eCount)=true) then eTemp[eCount] := 7 else
     eTemp[eCount] := 32;
 eScrnPtr := ((eConfigData^.cWidth)*(eCurrentData^.curReal[2]-1)*2);
 xmsGetDataFrom(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTemp);
 for eCount := (eCurrentData^.curReal[1]-1)*2 to (eConfigData^.cWidth*2) do
  eTemp[eCount] := eTemp[eCount+2];
 xmsMoveDataTo(eXmsHandle,eScrnPtr,eConfigData^.cWidth*2,@eTemp);
 eShowLine(eCurrentData^.curReal[2],eCurrentData^.curPos[2]);
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eCheckDefault;
 begin
 window(1,1,80,eBotPos[eCurrentData^.curRes]+1);
 cursor_off;
 gotoxy(1,1);textAttr := 7;clrEol;
 skawrite('|15D|07o |15y|07ou |15r|07eally |15w|07ant |15t|07o |15d|07efault'+
          ' |15y|07our |15f|07ont |15a|07nd |15p|07alette ? ');
 if (eSel=true) then eDefaultAdfData;
 window(1,2,80,eBotPos[eCurrentData^.curRes]+1);
 eSetResolution;
 cursor_on;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Function eCheckExit : boolean;
var tmp : boolean;
 eCount : word;
 begin
 window(1,1,80,eBotPos[eCurrentData^.curRes]+1);
 cursor_off;
 if (eCurrentData^.curChanges>0) then
  begin
  for eCount := 1 to 160 do if (odd(eCount)=true) then mem[$b800:(eBotPos[eCurrentData^.curRes]*160)+eCount] := 48 else
        mem[$b800:(eBotPos[eCurrentData^.curRes]*160)+eCount] := 32;
  gotoXY(1,eBotPos[eCurrentData^.curRes]+1);
  skaWrite('|B3|00 |00Note, '+strr(eCurrentData^.curChanges)+' alterations have been made'+
           ' to this image since last save');
  mem[$b800:((eBotPos[eCurrentData^.curRes]+1)*160)-2] := ord('');
  end;
 gotoxy(1,1);textAttr := 1;clrEol;
 skawrite('|15D|07o |15y|07ou |15r|07eally |15w|07ant |15t|07o |15q|07uit |15e|07mpathy? ');
 tmp := eSel;
 if (tmp=false) then
  begin eShowStatusBar(6); if (eCurrentData^.curChanges>0) then eUpdateScreen end;
 eCheckExit := tmp;
 window(1,2,80,eBotPos[eCurrentData^.curRes]+1);
 cursor_on;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Function eTransferRollover : boolean;
 begin
 eTransferRollover := false;
 if (eBlockData^.bInTransfer=false) then exit;
 if (eCurrentData^.curReal[1]+eBlockData^.bBlockWidth+1>eCurrentData^.curColStart+79) then eTransferRollOver := true;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Function eTransferOverRide : boolean;
 begin
 eTransferOverRide := false;
 if (eBlockData^.bInTransfer=false) then exit;
 if (eCurrentData^.curReal[1]+eBlockData^.bBlockWidth+1>eConfigData^.cWidth) then eTransferOverRide := true;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eGoLeft;
 begin
 if (eCurrentData^.curPos[1]<>1) then
  begin
  if (eCurrentData^.curInBlock=false) and (eBlockData^.bInTransfer=false) then
   begin
   dec(eCurrentData^.curPos[1]);
   dec(eCurrentData^.curReal[1]);
   end else
  if (eCurrentData^.curInBlock=true) and (eCurrentData^.curReal[1]>eBlockData^.bStartReal[1]) then
   begin
   dec(eBlockData^.bEndReal[1]);
   dec(eCurrentData^.curPos[1]);
   dec(eCurrentData^.curReal[1]);
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   end;
  if (eBlockData^.bInTransfer=true) then
   begin
   dec(eBlockData^.bTransStart[1]);
   dec(eCurrentData^.curPos[1]);
   dec(eCurrentData^.curReal[1]);
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   end;
  end else
 if (eCurrentData^.curPos[1]=1) and (eCurrentData^.curReal[1]>1) then
  begin
  if (eCurrentData^.curInBlock=false) and (eBlockData^.bInTransfer=false) then
   begin
   dec(eCurrentData^.curReal[1]);
   dec(eCurrentData^.curColStart);
   end else
  if (eCurrentData^.curInBlock=true) and (eCurrentData^.curReal[1]>eBlockData^.bStartReal[1]) then
   begin
   dec(eBlockData^.bEndReal[1]);
   dec(eCurrentData^.curReal[1]);
   dec(eCurrentData^.curColStart);
   end;
  if (eBlockData^.bInTransfer=true) then
   begin
   dec(eBlockData^.bTransStart[1]);
   dec(eCurrentData^.curColStart);
   dec(eCurrentData^.curReal[1]);
   end;
  if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
  end;
 eShowStatusBar(1);
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eGoRight;
 begin
 if ((eCurrentData^.curPos[1]<>80) and (eTransferRollOver=false)) then
  begin
  if (eBlockData^.bInTransfer=false) then
   begin
   inc(eCurrentData^.curPos[1]);
   inc(eCurrentData^.curReal[1]);
   if (eCurrentData^.curInBlock=true) then
    begin
    inc(eBlockData^.bEndReal[1]);
    if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
    end;
   end else
  if (eBlockData^.bInTransfer=true) then
   begin
   inc(eBlockData^.bTransStart[1]);
   inc(eCurrentData^.curPos[1]);
   inc(eCurrentData^.curReal[1]);
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   end;
  end else
 if (((eCurrentData^.curPos[1]=80) or (eTransferRollOver=true)) and (eCurrentData^.curReal[1]<eConfigData^.cWidth))  then
  begin
  if (eBlockData^.bInTransfer=false) then
   begin
   inc(eCurrentData^.curReal[1]);
   inc(eCurrentData^.curColStart);
   if (eCurrentData^.curInBlock=true) then
    begin
    inc(eBlockData^.bEndReal[1]);
    end;
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   end else if (eBlockData^.bInTransfer=true) and (eTransferOverRide=false) then
    begin
    inc(eCurrentData^.curColStart,1);
    inc(eCurrentData^.curReal[1]);
    inc(eBlockData^.bTransStart[1]);
    if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
    end;
  end;
 eShowStatusBar(1);
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eBackSpace;
 begin
 if (eCurrentData^.curPos[1]<>1) then
  begin
  dec(eCurrentData^.curPos[1],1);
  dec(eCurrentData^.curReal[1],1);
  end else
 if (eCurrentData^.curReal[1]<>1) then
  begin
  dec(eCurrentData^.curReal[1],1);
  dec(eCurrentData^.curColStart,1);
  if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
  end;
 eRemoveData;
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eGoDown;
 begin
 if (eCurrentData^.curPos[2]=eBotPos[eCurrentData^.curRes]) then
  begin
  if (eCurrentData^.curReal[2]+1<=eMaxLines) and (eBlockData^.bInTransfer=false) then
   begin
   inc(eCurrentData^.curStart);
   inc(eCurrentData^.curReal[2]);
   if (eCurrentData^.curInBlock=true) then
    begin
    inc(eBlockData^.bEndReal[2]);
    end;
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   eShowStatusBar(1);
   eGoPos;
   end else if (eBlockData^.bInTransfer=true) and (eBlockData^.bBlockLength+eCurrentData^.curReal[2]+1<=eMaxLines) then
    begin
    inc(eCurrentData^.curStart);
    inc(eCurrentData^.curReal[2]);
    if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
    eShowStatusBar(1);
    eGoPos;
    end;
  end else
   begin
   if (eBlockData^.bInTransfer=false) then
    begin
    inc(eCurrentData^.curPos[2]);
    inc(eCurrentData^.curReal[2]);
    end;
   if (eCurrentData^.curInBlock=true) then
    begin
    inc(eBlockData^.bEndReal[2]);
    if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
    end else
   if (eBlockData^.bInTransfer=true) and (eBlockData^.bBlockLength+eCurrentData^.curReal[2]+1<=eMaxLines) then
    begin
    inc(eCurrentData^.curPos[2]);
    inc(eCurrentData^.curReal[2]);
    inc(eBlockData^.bTransStart[2]);
    if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
    end;
   eShowStatusBar(1);
   eGoPos;
   end;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eGoUp;
 begin
 if (eCurrentData^.curPos[2]=1) then
  begin
  if (eBlockData^.bInTransfer=false) and (eCurrentData^.curReal[2]<>1) then
   begin
   if (eCurrentData^.curInBlock=false) then
    begin
    dec(eCurrentData^.curReal[2]);
    dec(eCurrentData^.curStart);
    end else if (eCurrentData^.curReal[2]>eBlockData^.bStartReal[2]) then
     begin
     dec(eCurrentData^.curReal[2]);
     dec(eCurrentData^.curStart);
     dec(eBlockData^.bEndReal[2]);
     end;
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   eShowStatusBar(1);
   eGoPos;
   end else if (eBlockData^.bInTransfer=true) and (eCurrentData^.curReal[2]<>1) then
    begin
    dec(eCurrentData^.curReal[2]);
    dec(eCurrentData^.curStart);
    if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
    eShowStatusBar(1);
    eGoPos;
    end;
  end else
   begin
   if (eCurrentData^.curInBlock=false) and (eBlockData^.bInTransfer=false) then
    begin
    dec(eCurrentData^.curPos[2]);
    dec(eCurrentData^.curReal[2]);
    end else if (eBlockData^.bStartReal[2]<>eCurrentData^.curReal[2]) and (eBlockData^.bInTransfer=false) then
     begin
     dec(eCurrentData^.curPos[2]);
     dec(eCurrentData^.curReal[2]);
     dec(eBlockData^.bEndReal[2]);
     if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
     end else if (eBlockData^.bInTransfer=true) then
      begin
      dec(eCurrentData^.curPos[2]);
      dec(eCurrentData^.curReal[2]);
      dec(eBlockData^.bTransStart[2]);
      if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
      end;
   eShowStatusBar(1);
   eGoPos;
   end;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
{ Note 9/2/02 :: Add BLOCK Support ! }

Procedure eGoPageUp;
 begin
 if (eCurrentData^.curStart>=eBotPos[eCurrentData^.curRes]+1) then
  begin
  dec(eCurrentData^.curStart,eBotPos[eCurrentData^.curRes]+1);
  dec(eCurrentData^.curReal[2],eBotPos[eCurrentData^.curRes]+1);
  if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
  eShowStatusBar(1);
  eGoPos;
  end else
   begin
   eCurrentData^.curStart   := 1;
   eCurrentData^.curPos[2]  := 1;
   eCurrentData^.curReal[2] := 1;
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   eShowStatusBar(1);
   eGoPos;
   end;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}
{ Note 9/2/02 :: Add BLOCK Support ! }

Procedure eGoPageDn;
 begin
 if (eCurrentData^.curStart+eBotPos[eCurrentData^.curRes]+1<=eMaxLines) then
  begin
  inc(eCurrentData^.curStart,eBotPos[eCurrentData^.curRes]+1);
  inc(eCurrentData^.curReal[2],eBotPos[eCurrentData^.curRes]+1);
  if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
  eShowStatusBar(1);
  eGoPos;
  end else
   begin
   eCurrentData^.curStart   := eMaxLines-(eBotPos[eCurrentData^.curRes]-1);
   eCurrentData^.curReal[2] := eMaxLines;
   eCurrentData^.curPos[2]  := eBotPos[eCurrentData^.curRes];
   if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
   eShowStatusBar(1);
   eGoPos;
   end;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure ePerformHelp;
var eCurrentScreen : byte;
    eInKey         : char;
    eDone          : boolean;
    eOldPal        : array[1..192] of byte;
    eOldFont       : array[1..4096] of byte;
    eOldRes        : byte;
 begin
 move(eCurrentData^.curFont,eOldFont,4096);
 move(eCurrentData^.curPal,eOldPal,192);
 eOldRes := eCurrentData^.curRes;
 eDefaultAdfData; eCurrentData^.curRes := 1;
 move(@eHelpScrnFont^,eCurrentData^.curFont,4096);
 move(@eHelpScrnPal^,eCurrentData^.curPal,192);
 eSetAdfAll; set8x16Font; blinking(false);
 move(@eHelpScrnImage^,mem[$b800:0],4000);
 cursor_off;
 eCurrentScreen := 1;
 eShowHelpPage(1);
 eDone := false;
  repeat
   repeat eInKey := readKey until (eInKey in [#73,#81,#13,#27]);
   case eInKey of
    #27 : eDone := true;
    #13 : eDone := true;
    #73 : if (eCurrentScreen>1) then
           begin
           dec(eCurrentScreen);
           eShowHelpPage(eCurrentScreen);
           end;
    #81 : if (eCurrentScreen<eHelpPages) then
           begin
           inc(eCurrentScreen);
           eShowHelpPage(eCurrentScreen);
           end;
   end;
  until (eDone=true);
 move(eOldFont,eCurrentData^.curFont,4096);
 move(eOldPal,eCurrentData^.curPal,192);
 eCurrentData^.curRes := eOldRes;
 if (eConfigData^.c8x16Mode=false) then asm mov ax, 3; int 10h end;
 if (eCurrentData^.curRes>1) then eSetResolution;
 eSetAdfAll;
 eShowStatusBar(6);
 if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
 cursor_on;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eGrabCursorAttribute;
Begin
  eScrnPtr := ((Pred(eCurrentData^.CurReal[2]) * eConfigData^.cWidth * 2) + Pred(eCurrentData^.CurReal[1]) * 2) + 1;
  xmsGetDataFrom (eXmsHandle, eScrnPtr, 1, @eCurrentData^.CurColor);
End;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDragAttribute;
 begin
 eScrnPtr := ((pred(eCurrentData^.curReal[2])*eConfigData^.cWidth*2)+pred(eCurrentData^.curReal[1])*2)+1;
 xmsMoveDataTo(eXmsHandle,eScrnPtr,1,@eCurrentData^.curColor);
 eShowLine(eCurrentData^.curReal[2],eCurrentData^.curPos[2]);
 if (eCurrentData^.curLength<eCurrentData^.curReal[2]) then
  eCurrentData^.curLength := eCurrentData^.curReal[2];
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoQuickPal;
var eCount  : byte;
    eDone   : boolean;
    eInKey  : string[2];
    eCurr   : array[1..2] of byte;
    eLast   : array[1..2] of byte;
    eHalf   : byte;
    eRuler  : boolean;
    eTopSet : byte;
    eSetNum : byte;

    Procedure eUpdateFunctionSets;
    const ePos : array[0..9] of byte = (6,6,5,5,4,4,3,3,2,2);
    var eCount : array[1..2] of byte;
     begin
     cursor_off;
     for eCount[1] := eTopSet to eTopSet+9 do
      begin
      if (eCount[1]=eSetNum) then textAttr := 11 else textAttr := 3;
      if (odd(eCount[1])=true) then gotoXY(45,eBotPos[eCurrentData^.curRes]-ePos[eCount[1]-eTopSet]) else
       gotoXY(56,eBotPos[eCurrentData^.curRes]-ePos[eCount[1]-eTopSet]);
      for eCount[2] := 1 to 10 do write(eConfigData^.cChars[eCount[1],eCount[2]]);
      end;
     eGoPos;
     end;

    Procedure eShowBars;
     begin
     gotoXY(13,(eBotPos[eCurrentData^.curRes]-6));
     if (eHalf=1) then skaWrite('|B0|11>>') else
         skaWrite('|B0|03  ');
     gotoXY(13,(eBotPos[eCurrentData^.curRes]-3));
     if (eHalf=2) then skaWrite('|B0|11>>') else
         skaWrite('|B0|03  ');
     gotoXY(15+eLast[1],(eBotPos[eCurrentData^.curRes]-4)); skaWrite(' ');
     gotoXY(15+eCurr[1],(eBotPos[eCurrentData^.curRes]-4)); if (eHalf=1) then skaWrite('|15|B0') else
            skaWrite('|08|B0');
     gotoXY(15+eLast[2],(eBotPos[eCurrentData^.curRes]-1)); skaWrite(' ');
     gotoXY(15+eCurr[2],(eBotPos[eCurrentData^.curRes]-1)); if (eHalf=2) then skaWrite('|15|B0') else
            skaWrite('|08|B0');
     eCurrentData^.curColor := eCurr[2]*16+eCurr[1];
     eShowStatusBar(2);
     end;

 begin
 eRuler := eCurrentData^.curRulerOn;
 eCurrentData^.curRulerOn := false;
 for eCount := (eBotPos[eCurrentData^.curRes]+1) downto (eBotPos[eCurrentData^.curRes]-8) do
  begin
  move(@eQuickPal^,mem[$b800:eCount*160],160*9);
  waitRetrace;
  end;
 window(1,1,eBotPos[eCurrentData^.curRes]+1,80);
 eCurr[1] := eCurrentData^.curColor and 15;
 eCurr[2] := (eCurrentData^.curColor shr 4) and 15;
 eLast[1]  := 1;
 eLast[2]  := 1;
 eHalf     := 1;
 for eCount := 1 to 20 do
  if ((odd(eCount)=true) and (eCurrentData^.curSet in [eCount..eCount+9])) then
   begin eTopSet := eCount; break end;
 gotoXY(27,eBotPos[eCurrentData^.curRes]);
 write('n/a');
 eSetNum   := eCurrentData^.curSet;
 cursor_off;
 eShowBars;
 eClearMouse; textAttr := 15;
 eUpdateFunctionSets;
 gotoXY(61,eBotPos[eCurrentData^.curRes]); write(comma(eCurrentData^.curLength));
 eGoPos;
  repeat
   eDone := false;
   repeat eInKey := eReadKey until (eInKey[1] in [#72,#80,#77,#75,#27,#13,#9]) or (eMouseUsed=true);
   case eInKey[1] of
   '8' : if (eMouseUsed=true) then
         begin
         if (eHalf=2) then begin eHalf := 1; eShowBars; end;
         end;
   '2' : if (eMouseUsed=true) then
         begin
         if (eHalf=1) then begin eHalf := 2; eShowBars; end;
         end;
   '6' : if (eMouseUsed=true) then
         begin
         eLast[eHalf] := eCurr[eHalf];
         if (eCurr[eHalf]<>15) then inc(eCurr[eHalf]) else eCurr[eHalf] := 0;
         eShowBars;
         end;
   '4' : if (eMouseUsed=true) then
         begin
         eLast[eHalf] := eCurr[eHalf];
         if (eCurr[eHalf]<>0) then dec(eCurr[eHalf]) else eCurr[eHalf] := 15;
         eShowBars;
         end;
   #9  : begin
         if (eSetNum<20) then
          begin
          if (eSetNum=eTopSet+9) then inc(eTopSet,2);
          inc(eSetNum);
          end else
           begin
           eSetNum := 1;
           eTopSet := 1;
           end;
         eUpdateFunctionSets;
         eCurrentData^.curSet := eSetNum;
         eLoadSet(eSetNum);
         eShowStatusBar(5);
         end;
   #72 : begin
         if (eHalf=2) then begin eHalf := 1; eShowBars; end;
         end;
   #80 : begin
         if (eHalf=1) then begin eHalf := 2; eShowBars; end;
         end;
   #77 : begin
         eLast[eHalf] := eCurr[eHalf];
         if (eCurr[eHalf]<>15) then inc(eCurr[eHalf]) else eCurr[eHalf] := 0;
         eShowBars;
         end;
   #75 : begin
         eLast[eHalf] := eCurr[eHalf];
         if (eCurr[eHalf]<>0) then dec(eCurr[eHalf]) else eCurr[eHalf] := 15;
         eShowBars;
         end;
   #27 : eDone := true;
   #13 : eDone := true;
   'B' : if (eMouseUsed=true) then eDone := true;
   'Q' : if (eMouseUsed=true) then eDone := true;
   end;
  if (eMouseUsed=true) then eMouseUsed := false;
  until (eDone=true);
 eClearMouse;
 for eCount := (eBotPos[eCurrentData^.curRes]-8) to (eBotPos[eCurrentData^.curRes]+1) do
  begin
  move(@eQuickPal^,mem[$b800:eCount*160],160*9);
  eShowLine(eCurrentData^.curStart+eCount-1,eCount);
  waitRetrace;
  end;
 eCurrentData^.curRulerOn := eRuler;
 if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eCheckClear;

   Procedure eDoClear;
    begin
    eClearXms;
    eCurrentData^.curChanges := 0;
    eCurrentData^.curStart   := 1;
    eCurrentData^.curPos[1]  := 1;
    eCurrentData^.curPos[2]  := 1;
    eCurrentData^.curReal[1] := 1;
    eCurrentData^.curReal[2] := 1;
    end;

 begin
 if not eConfigData^.cClear then eDoClear else
  begin
  window(1,1,80,eBotPos[eCurrentData^.curRes]+1);
  cursor_off;
  gotoxy(1,1);textAttr := 7;clrEol;
  skawrite('|15D|07o |15y|07ou |15r|07eally |15w|07ant |15t|07o |15c|07lear |15t|07he |15p|07age ? ');
  if (eSel=true) then eDoClear;
  end;
 if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
 eShowStatusBar(6);
 eGoPos;
 window(1,2,80,eBotPos[eCurrentData^.curRes]+1);
 cursor_on;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Function eGetBlockFunction : byte;
const ePos : array[1..7] of byte = (31,38,44,50,56,62,67);
     eStr1 : array[1..7] of string[15] = (' |15E|07rase ',' |15M|07ove ',' |15C|07opy ',' |15S|07ave ',
                                          ' |15F|07ill ',' |15B|07ox ',' |15R|07eplace ');
     eStr2 : array[1..7] of string[15] = (' |15E|00rase ',' |15M|00ove ',' |15C|00opy ',' |15S|00ave ',
                                          ' |15F|00ill ',' |15B|00ox ',' |15R|00eplace ');
var eBars  : array[1..2] of byte;
    eDone  : boolean;
    eCount : byte;
    eInKey : string[2];

    Procedure eShowBars;
     begin
     gotoXY(ePos[eBars[1]],1);
     skaWrite('|B0'+eStr1[eBars[1]]);
     gotoXY(ePos[eBars[2]],1);
     skaWrite('|B3'+eStr2[eBars[2]]);
     end;

 begin
 eClearMouse;
 window(1,1,80,eBotPos[eCurrentData^.curRes]+1); textAttr := 7; clrEol;
 skaWrite('|15P|07lease |15s|07elect |15b|07lock |15f|07unction: ');
 eBars[2] := 1;
 for eCount := 1 to 7 do begin eBars[1] := eCount; eShowBars; end;
 eClearMouse;
 eMouseUsed := false;
  repeat
  eDone := false;
  eInKey := eReadKey;
   case upCase(eInKey[1]) of
   'E' : if (eMouseUsed=false) then begin
         eGetBlockFunction := 1;
         eDone := true;
         end;
   'M' : if (eMouseUsed=false) then begin
         eGetBlockFunction := 2;
         eDone := true;
         end;
   'C' : if (eMouseUsed=false) then begin
         eGetBlockFunction := 3;
         eDone := true;
         end;
   'S' : if (eMouseUsed=false) then begin
         eGetBlockFunction := 4;
         eDone := true;
         end;
   'F' : if (eMouseUsed=false) then begin
         eGetBlockFunction := 5;
         eDone := true;
         end;
   'B' : if (eMouseUsed=false) then begin
         eGetBlockFunction := 6;
         eDone := true;
         end else
          begin
          eGetBlockFunction := eBars[2];
          eDone := true;
          end;
   'R' : if (eMouseUsed=false) then begin
         eGetBlockFunction := 7;
         eDone := true;
         end;
   'Q' : if (eMouseUsed=true) then
           begin
           eGetBlockFunction := 0;
           eDone := true;
           end;
   #13 : begin
         eGetBlockFunction := eBars[2];
         eDone := true;
         end;
   #27 : begin
         eGetBlockFunction := 0;
         eDone := true;
         end;
   '4' : if (eMouseUsed=true) then
          begin
          eBars[1] := eBars[2];
          if (eBars[2]<>1) then dec(eBars[2]);
          eShowBars;
          end;
   '6' : if (eMouseUsed=true) then begin
         eBars[1] := eBars[2];
         if (eBars[2]<>7) then inc(eBars[2]);
         eShowBars;
         end;
    #0 : begin
         eInKey := eReadKey;
          case eInKey[1] of
          #77 : begin
                eBars[1] := eBars[2];
                if (eBars[2]<>7) then inc(eBars[2]);
                eShowBars;
                end;
          #75 : begin
                eBars[1] := eBars[2];
                if (eBars[2]<>1) then dec(eBars[2]);
                eShowBars;
                end;
          end;
         end;
   end;
  if (eMouseUsed=true) then eMouseUsed := false;
  until (eDone=true);
 eClearMouse;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eSetupBlockLast(store : boolean);
Begin
  If Store Then Begin
    eBlockData^.bBlockLast[1] := eCurrentData^.CurColStart;
    eBlockData^.bBlockLast[2] := eCurrentData^.CurPos[1];
    eBlockData^.bBlockLast[3] := eCurrentData^.CurPos[2];
    eBlockData^.bBlockLast[4] := eCurrentData^.CurReal[1];
    eBlockData^.bBlockLast[5] := eCurrentData^.CurReal[2];
    eBlockData^.bBlockLast[6] := eCurrentData^.CurStart;
  End Else Begin
    eCurrentData^.CurColStart := eBlockData^.bBlockLast[1];
    eCurrentData^.CurPos[1]   := eBlockData^.bBlockLast[2];
    eCurrentData^.CurPos[2]   := eBlockData^.bBlockLast[3];
    eCurrentData^.CurReal[1]  := eBlockData^.bBlockLast[4];
    eCurrentData^.CurReal[2]  := eBlockData^.bBlockLast[5];
    eCurrentData^.CurStart    := eBlockData^.bBlockLast[6];
  End;
End;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoBlockTransfer(move : byte);
const eName  : array[0..1] of string[10] = ('|15M|07ove','|15C|07opy');
var   eDone  : boolean;
      eInKey : string[8];
      eCount : byte;
      eOldPg : byte;
      eDoCount : byte;

      Procedure eShowInfoLine;
       begin
       window(1,1,80,eBotPos[eCurrentData^.curRes]+1);textAttr := 7;gotoXY(1,1);clrEol;eShowStatusBar(1);
       window(1,1,80,eBotPos[eCurrentData^.curRes]+1);gotoXY(14,1);
       skaWrite('|07|15B|07lock '+eName[move]+' |07- |08(|03cr|08) |15P|07laces, ');
       if (move=1) then skaWrite('|08(|03S|08) |15S|07tamps, ');
       skaWrite('|08(|030..9|08) |15P|07age, |08(|03esc|08) |15A|07borts..');
       window(1,2,80,eBotPos[eCurrentData^.curRes]+1);
       end;

 begin
 eSetupBlockLast(false); eBlockData^.bInTransfer := false; eUpdateScreen;
 eBlockData^.bInTransfer    := true;
 if (move=0) then eBlockData^.bMove := true else eBlockData^.bMove := false;
 eBlockData^.bTransStart[1] := eCurrentData^.curReal[1];
 eBlockData^.bTransStart[2] := eCurrentData^.curReal[2];
 eBlockData^.bBlockLength   := (eBlockData^.bEndReal[2]-eBlockData^.bStartReal[2]);
 eBlockData^.bBlockWidth    := (eBlockData^.bEndReal[1]-eBlockData^.bStartReal[1]);
 eBlockData^.bFinal         := false;
 eCurrentData^.curInBlock   := false;
 eOldPg := eCurrentData^.curPage;
 eDone := false;
 eSetupBlockFile(0);
 eShowInfoLine;
 if (move=0) then eSetupBlockFile(3);
 eGoPos; if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
 repeat
  repeat
   eInKey := eReadKey until (upCase(eInKey[1]) in [#9,#15,#72,#80,#77,#75,#13,#27,'S',#81,#73,#48..#57]) or (eMouseUsed=true);
  if (eMouseUsed=true) then for eCount := 1 to length(eInKey) do
   case eInKey[eCount] of
   '8' : eGoUp;
   '4' : eGoLeft;
   '6' : eGoRight;
   '2' : eGoDown;
   'B' : begin eDoDataTransfer(move); eDone := true end;
   'Q' : begin
         if (eOldPg<>eCurrentData^.curPage) then
          begin eSwitchPages(eOldPg); eGoPos; eShowStatusBar(6) end;
         if (move=0) then eSetupBlockFile(2);
         eDone := true
         end;
   end else
   case upCase(eInKey[1]) of
   #13 : begin
         eBlockData^.bFinal := true;
         eDoDataTransfer(move);
         eDone := true;
         end;
   'S' : if (move=1) then
         eDoDataTransfer(move);
   #27 : begin
         if (eOldPg<>eCurrentData^.curPage) then
          begin eSwitchPages(eOldPg); eGoPos; eShowStatusBar(6) end;
         if (move=0) then eSetupBlockFile(2);
         eDone := true
         end;
   #75 : eGoLeft;
   #77 : eGoRight;
   #80 : eGoDown;
   #72 : eGoUp;
   #9  : for eDoCount := 1 to 8 do eGoRight;
   #15 : for eDoCount := 1 to 8 do eGoLeft;
   #81 : for eDoCount := 1 to eBotPos[eCurrentData^.curRes]-2 do eGoDown;
   #73 : for eDoCount := 1 to eBotPos[eCurrentData^.curRes]-2 do eGoUp;
   #48..#57
       : begin
         eSwitchPages(ord(eInKey[1])-48);
         eBlockData^.bTransStart[1] := eCurrentData^.curReal[1];
         eBlockData^.bTransStart[2] := eCurrentData^.curReal[2];
         eUpdateScreen;
         eShowInfoLine;
         end;
   end;
 until (eDone=true);
 eSetupBlockFile(1);
 eBlockData^.bTransStart[2] := eCurrentData^.curReal[2];
 if (eBlockData^.bTransStart[2]+eBlockData^.bBlockLength>eCurrentData^.curLength) then
     eCurrentData^.curLength := eBlockData^.bTransStart[2]+eBlockData^.bBlockLength;
 eBlockData^.bInTransfer := false;
 eBlockData^.bMove := false;
 eUpdateScreen;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Function eGetFillType : byte;
const eTypes1 : array[1..3] of string[22] = (' |15C|07haracter ',' |15A|07ttribute ',' |07C|15o|07mbination ');
      eTypes2 : array[1..3] of string[22] = (' |15C|00haracter ',' |15A|00ttribute ',' |00C|15o|00mbination ');
      ePos    : array[1..3] of byte = (34,45,56);
var   eInChar : string[2];
      eCount  : byte;
      eBars   : array[1..2] of byte;
      eDone   : boolean;

      Procedure eGetFillCharacter;
       begin
       skaWrite('|15E|07nter |15f|07ill |15c|07har |08(|03F1-F10 active|08)|07: ');
       eShowStatusBar(5);
       window(1,1,80,25); gotoXY(34,1);
        repeat
        eInChar[1] := readKey;
        if (eInChar[1]=#0) then
         begin
         eInChar[1] := readKey;
         if (eInChar[1] in [#59..#68]) then
          begin eInChar[1] := eCurrentSet[ord(eInChar[1])-58]; eDone := true end;
         if (eInChar[1] in [#104..#133]) then
          begin eLoadSet(ord(eInChar[1])-103); eShowStatusBar(5);
           window(1,1,80,25); gotoXY(34,1) end;
         if (eInChar[1] in [#94..#98]) then
          begin eLoadSet(ord(eInChar[1])-83); eShowStatusBar(5);
           window(1,1,80,25); gotoXY(34,1) end;
         end else eDone := true;
        until (eDone=true);
       window(1,2,80,25);
       eBlockData^.bFillData[1] := ord(eInChar[1]);
       end;

      Procedure ePlaceBars;
       begin
       gotoXY(ePos[eBars[1]],1); skaWrite('|B0'+eTypes1[eBars[1]]);
       gotoXY(ePos[eBars[2]],1); skaWrite('|B3'+eTypes2[eBars[2]]);
       end;

 begin
 for eCount := 1 to 160 do mem[$b800:eCount] := 0;
 gotoXY(1,1); skaWrite('|B0|15P|07lease |15s|07elect |15b|07lock |15f|07ill |15m|07ethod: ');
 eDone := false; eBars[1] := 1; eBars[2] := 1;
 for eCount := 1 to 3 do begin eBars[1] := eCount; ePlaceBars end;
  repeat
  eInChar := eReadKey;
  if (eMouseUsed=true) then
   case eInChar[1] of
    '4' : begin
          eBars[1] := eBars[2];
          if (eBars[2]>1) then
           begin dec(eBars[2]); ePlaceBars end;
          end;
    '6' : begin
          eBars[1] := eBars[2];
          if (eBars[2]<3) then
           begin inc(eBars[2]); ePlaceBars end;
          end;
    'B' : eDone := true;
    'Q' : begin eBars[2] := 0; eDone := true end;
   end else
    case upCase(eInChar[1]) of
     'C' : begin eBars[2] := 1; eDone := true end;
     'A' : begin eBars[2] := 2; eDone := true end;
     'O' : begin eBars[2] := 3; eDone := true end;
     #13 : eDone := true;
     #27 : begin eBars[2] := 0; eDone := true end;
     #75 : begin
           eBars[1] := eBars[2];
           if (eBars[2]>1) then
            begin dec(eBars[2]); ePlaceBars end;
           end;
     #77 : begin
           eBars[1] := eBars[2];
           if (eBars[2]<3) then
            begin inc(eBars[2]); ePlaceBars end;
           end;
    end;
  until (eDone=true);
 eGetFillType := eBars[2];
 gotoXY(1,1); textAttr := 7; clrEol; gotoXY(1,1);
 eDone := false;
 case eBars[2] of
  1 : eGetFillCharacter;
  2 : begin
      eDoAttributeSelection(1);
      eBlockData^.bFillData[2] := eCurrentData^.curColor;
      end;
  3 : begin
      eGetFillCharacter;
      eDoAttributeSelection(1);
      eBlockData^.bFillData[2] := eCurrentData^.curColor;
      end;
  end;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Function eGetReplaceType : byte;
const eTypes1 : array[1..2] of string[20] =
      (' |15A|07ttribute ',' |15C|07haracter ');
      eTypes2 : array[1..2] of string[20] =
      (' |15A|00ttribute ',' |15C|00haracter ');
      ePos : array[1..2] of byte = (35,46);
var eBars  : array[1..2] of byte;
    eInKey : string[2];
    eDone  : boolean;
    eCount : byte;

    Procedure eShowBars;
     begin
     gotoXY(ePos[eBars[1]],1); skaWrite('|B0'+eTypes1[eBars[1]]);
     gotoXY(ePos[eBars[2]],1); skaWrite('|B3'+eTypes2[eBars[2]]);
     end;

    Procedure eGetReplaceCharacter(num : byte);
     begin
     gotoXY(1,1); textAttr := 7; clrEol;
     if (num=1) then skaWrite('|15E|07nter |15o|07ld |15c|07har |15t|07o |15b|07e |15r|07eplaced|08: ') else
     skaWrite('|15E|07nter |15n|07ew |15c|07har |15t|07o |15r|07eplace |15o|07ld|08: ');
     eShowStatusBar(5);
     window(1,1,80,25); gotoXY(32,1);
      repeat
      eInKey[1] := readKey;
      if (eInKey[1]=#0) then
       begin
       eInKey[1] := readKey;
       if (eInKey[1] in [#59..#68]) then
        begin eInKey[1] := eCurrentSet[ord(eInKey[1])-58]; eDone := true end;
       if (eInKey[1] in [#104..#133]) then
        begin eLoadSet(ord(eInKey[1])-103); eShowStatusBar(5);
         window(1,1,80,25); gotoXY(34,1) end;
       if (eInKey[1] in [#94..#98]) then
        begin eLoadSet(ord(eInKey[1])-83); eShowStatusBar(5);
         window(1,1,80,25); gotoXY(34,1) end;
       end else eDone := true;
      until (eDone=true);
     end;

 begin
 window(1,1,80,25); gotoXY(1,1); textAttr := 7; clrEol;
 skaWrite('|15P|07lease |15s|07elect |15b|07lock |15r|07eplace |15t|07ype|08: ');
 eBars[2] := 1; eBars[1] := 2; eShowBars;
 eDone := false;
  repeat
   repeat eInKey := eReadKey until (upCase(eInKey[1]) in [#75,#77,#27,#13,'4','6','B','Q','A','C']);
   case upCase(eInKey[1]) of
    'A' : begin eBars[2] := 1; eDone := true end;
    'C' : begin eBars[2] := 2; eDone := true end;
    'B' : if (eMouseUsed=true) then eDone := true;
    'Q' : if (eMouseUsed=true) then begin eDone := true; eBars[2] := 0 end;
    '4' : if (eBars[2]>1) then
           begin
           eBars[1] := eBars[2];
           dec(eBars[2],1);
           eShowBars;
           end;
    '6' : if (eBars[2]<2) then
           begin
           eBars[1] := eBars[2];
           inc(eBars[2],1);
           eShowBars;
           end;
    #27 : begin eDone := true; eBars[2] := 0 end;
    #13 : eDone := true;
    #75 : if (eBars[2]>1) then
           begin
           eBars[1] := eBars[2];
           dec(eBars[2],1);
           eShowBars;
           end;
    #77 : if (eBars[2]<2) then
           begin
           eBars[1] := eBars[2];
           inc(eBars[2],1);
           eShowBars;
           end;
   end;
  until (eDone=true);
 eGetReplaceType := eBars[2];
  case eBars[2] of
   1 : begin
       eDoAttributeSelection(2);
       eBlockData^.bReplData[1] := eCurrentData^.curColor;
       eDoAttributeSelection(3);
       eBlockData^.bReplData[2] := eCurrentData^.curColor;
       end;
   2 : begin
       eGetReplaceCharacter(1);
       eBlockData^.bReplData[3] := ord(eInKey[1]);
       eGetReplaceCharacter(2);
       eBlockData^.bReplData[4] := ord(eInKey[1]);
       end;
  end;
 eShowStatusBar(6);
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eUnSupported;
Begin
  eErrorPause ('Error, function not yet implemented');
End;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoBlockFunctions;
var eDone  : boolean;
    eInKey : string[8];
    eFunct : byte;
    eRuler : boolean;
    eCount : byte;
    eDoCount : byte;
 begin
 eCurrentData^.curInBlock  := true;
 eRuler := eCurrentData^.curRulerOn;
 eBlockData^.bStartReal[1] := eCurrentData^.curReal[1];
 eBlockData^.bStartReal[2] := eCurrentData^.curReal[2];
 eBlockData^.bEndReal[1]   := eCurrentData^.curReal[1];
 eBlockData^.bEndReal[2]   := eCurrentData^.curReal[2];
 window(1,1,80,eBotPos[eCurrentData^.curRes]+1);textAttr := 7;gotoXY(1,1);clrEol;eShowStatusBar(1);
 window(1,1,80,eBotPos[eCurrentData^.curRes]+1);gotoXY(15,1);
 skaWrite('|15S|07elect |15b|07lock |15t|07o |15m|07anipulate: |08(|03CR|08)|07 Confirms |08(|03SPACE|08)|07 Toggles ruler');
 window(1,2,80,eBotPos[eCurrentData^.curRes]+1);eGoPos;
 if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
 cursor_off;
 eClearMouse;
 eSetupBlockLast(true);
 repeat
  eDone := false;
  repeat eInKey := eReadKey until (eInkey[1] in [#72,#80,#75,#77,#13,#32,#9,#71,#79,#81,#73,#9,#15]) or (eMouseUsed=true);
  if (eMouseUsed=true) then for eCount := 1 to length(eInKey) do
   case eInKey[eCount] of
   '8' : eGoUp;
   '4' : eGoLeft;
   '6' : eGoRight;
   '2' : eGoDown;
   'B' : eDone := true;
   end else
  case eInKey[1] of
   #13 : eDone := true;
   #71 : begin  { Home }
         if (eBlockData^.bStartReal[1]<eCurrentData^.curColStart) then
          begin
           eBlockData^.bEndReal[1] := eCurrentData^.curColStart;
           eCurrentData^.curReal[1] := eCurrentData^.curColStart;
           eCurrentData^.curPos[1] := eCurrentData^.curReal[1]-pred(eCurrentData^.curColStart);
          end else
         if (eBlockData^.bStartReal[1]>=eCurrentData^.curColStart) then
          begin
          eBlockData^.bEndReal[1] := eBlockData^.bStartReal[1];
          eCurrentData^.curReal[1] := eBlockData^.bStartReal[1];
          eCurrentData^.curPos[1] := eCurrentData^.curReal[1]-pred(eCurrentData^.curColStart);
          end;
         eUpdateScreen;
         eGoPos;
         eShowStatusBar(1);
         end;
   #79 : begin { End }
         eBlockData^.bEndReal[1] := eCurrentData^.curColStart+79;
         eCurrentData^.curReal[1] := eCurrentData^.curColStart+79;
         eCurrentData^.curPos[1] := 80;
         eUpdateScreen;
         eGoPos;
         eShowStatusBar(1);
         end;
   #75 : eGoLeft;
   #77 : eGoRight;
   #80 : eGoDown;
   #72 : eGoUp;
   #81 : for eDoCount := 1 to eBotPos[eCurrentData^.curRes]+1 do eGoDown;
   #73 : for eDoCount := 1 to eBotPos[eCurrentData^.curRes]+1 do eGoUp;
   #9  : for eDoCount := 1 to 8 do eGoRight;
   #15 : for eDoCount := 1 to 8 do eGoLeft;
   #32 : begin eCurrentData^.curRulerOn := not eCurrentData^.curRulerOn; eUpdateScreen; eGoPos end;
  end;
 if (eMouseUsed=true) then eMouseUsed := false;
 until (eDone=true);
 eClearMouse;
 eFunct := eGetBlockFunction;
  case eFunct of
   1 : eDoBlockErase;
   2 : eDoBlockTransfer(0);
   3 : eDoBlockTransfer(1);
   4 : eUnSupported;
   5 : eDoBlockFill(eGetFillType);
   6 : eUnSupported;
   7 : eDoBlockReplace(eGetReplaceType);
  end;
 eClearMouse;
 eCurrentData^.curInBlock := false;
 cursor_on;
 eCurrentData^.curRulerOn := eRuler;
 eShowStatusBar(6);
 if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
 eGoPos;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoGlobalBlockFunctions;
Var
  eFunct : Byte;
Begin
  If eCurrentData^.CurLength = 0 Then Begin
    eErrorPause('Error, current page is blank - globals disabled');
    Exit;
  End;

  eCurrentData^.CurInBlock  := True;

  eSetupBlockLast(True);

  eBlockData^.bStartReal[1] := 1;
  eBlockData^.bStartReal[2] := 1;
  eBlockData^.bEndReal[1]   := eConfigData^.cWidth;
  eBlockData^.bEndReal[2]   := eCurrentData^.curLength;

  eUpdateScreen;
  eClearMouse;

  eFunct := eGetBlockFunction;

  Case eFunct of
    1 : eDoBlockErase;
    2 : eDoBlockTransfer(0);
    3 : eDoBlockTransfer(1);
    4 : eUnSupported;
    5 : eDoBlockFill(eGetFillType);
    6 : eUnSupported;
    7 : eDoBlockReplace(eGetReplaceType);
  End;

  eClearMouse;
  eCurrentData^.CurInBlock := False;
  Cursor_On;
  eShowStatusBar(6);
  If Not eCurrentData^.CurRulerOn Then eUpdateScreen;
  eGoPos;
End;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eCycleColors (eDirection: Byte);
Var
  eColors : Array[1..2] of Byte;
Begin
  eColors[1] := eCurrentData^.CurColor DIV 16;
  eColors[2] := eCurrentData^.CurColor MOD 16;

  Case eDirection of
    1 : If eColors[2] < 15 Then Inc(eColors[2]) Else eColors[2] := 0;
    2 : If eColors[2] > 0  Then Dec(eColors[2]) Else eColors[2] := 15;
    3 : If eColors[1] > 0  Then Dec(eColors[1]) Else eColors[1] := 15;
    4 : If eColors[1] < 15 Then Inc(eColors[1]) Else eColors[1] := 0;
  End;

  eCurrentData^.CurColor := eColors[1] * 16 + eColors[2];

  eShowStatusBar(2);
End;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eSelectPage;
Var
  eInPage : Char;
Begin
  Window (1, 1, 80, 25);
  TextAttr := 7;
  GotoXY (1, 1);
  ClrEol;
  GotoXY (1, 1);
  skaWrite('|15P|07lease |15e|07nter |15t|07he |15s|07wap |15p|07age |07(|030-9|07) |15t|07o |15s|07witch |15t|07o|08: ');
  eInPage := ReadKey;
  If eInPage in ['0'..'9'] Then eSwitchPages(Ord(eInPage) - 48);
  Window(1, 2, 80, 25);
End;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eDoAttributeSelection(fill : byte);
var eInKey : string[2];
    eBars  : array[1..2,1..2] of byte;
    eColor : byte;
    eCount : byte;
    eSet   : byte;
    eDone  : boolean;
    eStr   : array[1..2] of string[2];

    Procedure eShowBars;
     begin
      gotoXY(70,3+eBars[1,1]);
      skaWrite('|B0 ');
      gotoXY(70,3+eBars[1,2]);
      skaWrite('|B0|07>');
      gotoXY(73,3+eBars[2,1]);
      skaWrite('|B0 ');
      gotoXY(73,3+eBars[2,2]);
      skaWrite('|B0|07>');
      gotoXY(62,22);
      skaWrite('|B7|00'+eTab(eStr[1],2));
      gotoXY(78,22);
      skaWrite('|B7|00'+eTab(eStr[2],2));
     end;

 begin
 eToggleTo25Lines(true); asm mov ax, 3; int 10h end;
 for eCount := 0 to 63 do
     eSetAdfPalette(eCount,eCurrentData^.curPal[eCount,1],eCurrentData^.curPal[eCount,2],eCurrentData^.curPal[eCount,3]);
 eClearMouse;
 move(@eAttribScrn^,mem[$b800:0],4000);
 window(1,2,80,25);
 if (fill>0) then
  begin
  for eCount := 1 to 160 do if (odd(eCount)=true) then mem[$b800:(eBotPos[eCurrentData^.curRes]*160)+eCount] := 48 else
      mem[$b800:(eBotPos[eCurrentData^.curRes]*160)+eCount] := 32;
  gotoXY(1,eBotPos[eCurrentData^.curRes]);
  if (fill=1) then skaWrite('|B3|00 |00Please select the attribute to fill selected block with') else
  if (fill=2) then skaWrite('|B3|00 |00Please first select the old attribute to be replaced') else
  if (fill=3) then skaWrite('|B3|00 |00Please now select the new attribute to replace the old attribute with');
  mem[$b800:((eBotPos[eCurrentData^.curRes]+1)*160)-2] := ord('');
  end;
 cursor_off;
 eSet := 1;
 eBars[1,1] := 0;
 eBars[2,1] := 0;
 eBars[1,2] := eCurrentData^.curColor mod 16;
 eBars[2,2] := eCurrentData^.curColor div 16;
 eStr[1] := '';
 eStr[2] := '';
 eShowBars;
 eDone := false;
  repeat
  eInKey := eReadKey;
   if (eMouseUsed=true) then
    case eInKey[1] of
     'Q' : eDone := true;
     'B' : if (eSet=1) then
            begin
            eSet := 2;
            eBars[1,1] := eBars[1,2];
            eBars[1,2] := str2byte(eStr[1]);
            eShowBars;
            eClearMouse;
            end else
             begin
             eCurrentData^.curColor := str2byte(eStr[2])*16+str2byte(eStr[1]);
             eDone := true;
             eClearMouse;
             end;
     '8' : begin
           eBars[eSet,1] := eBars[eSet,2];
           if (eBars[eSet,2]<>0) then dec(eBars[eSet,2]) else
               eBars[eSet,2] := 15;
           eStr[eSet] := strr(eBars[eSet,2]);
           eShowBars;
           end;
     '2' : begin
           eBars[eSet,1] := eBars[eSet,2];
           if (eBars[eSet,2]<>15) then inc(eBars[eSet,2]) else
               eBars[eSet,2] := 0;
           eStr[eSet] := strr(eBars[eSet,2]);
           eShowBars;
           end;
    end else
   case eInKey[1] of
   #27      : eDone := true;
   #8       : if (ord(eStr[eSet][0])>0) then
              begin
              dec(eStr[eSet][0]);
              eShowBars;
              end;
   #13      : if (eSet=1) then
              begin
              eSet := 2;
              if (eStr[1]='') then eStr[1] := strr(eBars[1,2]);
              eBars[1,1] := eBars[1,2];
              eBars[1,2] := str2byte(eStr[1]);
              eShowBars;
              end else
               begin
               if (eStr[2]='') then eStr[2] := strr(eBars[2,2]);
               eCurrentData^.curColor := str2byte(eStr[2])*16+str2byte(eStr[1]);
               eDone := true;
               end;
   '0'..'9' : begin
              if (str2byte(eStr[eSet])<=1) then
               eStr[eSet] := eStr[eSet] + eInKey;
              eShowBars;
              end;
   #0 : begin
        eInKey := eReadKeyboard;
         case eInKey[1] of
         #72 : begin
               eBars[eSet,1] := eBars[eSet,2];
               if (eBars[eSet,2]<>0) then dec(eBars[eSet,2]) else
                   eBars[eSet,2] := 15;
               eStr[eSet] := strr(eBars[eSet,2]);
               eShowBars;
               end;
         #80 : begin
               eBars[eSet,1] := eBars[eSet,2];
               if (eBars[eSet,2]<>15) then inc(eBars[eSet,2]) else
                   eBars[eSet,2] := 0;
               eStr[eSet] := strr(eBars[eSet,2]);
               eShowBars;
               end;
         end;
        end;
   end;
  if (eMouseUsed=true) then eMouseUsed := false;
  until (eDone=true);
 eClearMouse;
 eToggleTo25Lines(false);
 eSetAdfAll;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eSetNewImageEnd;
 var eOldEnd : longInt;
 begin
 window(1,1,80,eBotPos[eCurrentData^.curRes]+1);
 cursor_off;
 gotoxy(1,1);textAttr := 7;clrEol;
 skawrite('|15D|07o |15y|07ou |15r|07eally |15w|07ant |15t|07o |15s|07et'+
          ' |15l|07ine |14'+strr(eCurrentData^.curReal[2])+' |15t|07he |15e|07nd |15o|07f |15y|07our |15i|07mage? ');
 if (eSel=true) then
  begin
   eOldEnd := eCurrentData^.curLength;
   eCurrentData^.curLength := eCurrentData^.curReal[2];
   { clear xms here }
   eBlockData^.bStartReal[1] := 1;
   eBlockData^.bStartReal[2] := eCurrentData^.curReal[2]+1;
   eBlockData^.bEndReal[1] := eConfigData^.cWidth;
   eBlockData^.bEndReal[2] := eOldEnd;
   eDoBlockErase;
  end;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eScreenEditor;
 var eInChar : string[8];
     eDone   : boolean;
     eFound  : boolean;
     eCount  : byte;
     eDoFunc : byte;
 begin
  eCurrentData^.curInBlock := false;
  cursor_on;
  repeat
  eDone   := false;
  repeat eInChar := eReadKey until (eInChar<>'none');
  if (eMouseUsed=true) then
   begin
   eDoFunc := 0;
   for eCount := 1 to length(eInChar) do
    case eInChar[eCount] of
     '8' : eGoUp;
     '2' : eGoDown;
     '4' : eGoLeft;
     '6' : eGoRight;
     'B' : eDoFunc := 1;
     'Q' : eDoFunc := 2;
    end;
   if (eDoFunc=1) then eDoBlockFunctions else
   if (eDoFunc=2) then eDoQuickPal;
   eMouseUsed := false;
   eMoveMouse(2,2);
   end else
  begin
   case ord(eInChar[1]) of
    eTabKey              : begin
                           if (eCurrentData^.curPos[1]+8>80) and (eConfigData^.cWidth>80) and
                              (eCurrentData^.curColStart<eConfigData^.cWidth-80) then
                            begin
                            inc(eCurrentData^.curReal[1],8);
                            inc(eCurrentData^.curColStart,8);
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(1);
                            eGoPos;
                            end else if (eCurrentData^.curPos[1]+8<80) then
                             begin
                             inc(eCurrentData^.curPos[1],8);
                             inc(eCurrentData^.curReal[1],8);
                             if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                             eShowStatusBar(1);
                             eGoPos;
                             end;
                           end;
    eBackSpcKey          : eBackSpace;
    eEscapeKey           : eDoQuickPal;
    eEnterKey            : begin
                           if (eCurrentData^.curReal[2]<>eMaxLines) then
                            begin
                            if (eCurrentData^.curPos[2]<>eBotPos[eCurrentData^.curRes]) then
                             begin
                             inc(eCurrentData^.curReal[2]);
                             inc(eCurrentData^.curPos[2]);
                             eCurrentData^.curReal[1] := 1;
                             eCurrentData^.curPos[1]  := 1;
                             end else
                              begin
                              inc(eCurrentData^.curStart);
                              inc(eCurrentData^.curReal[2]);
                              eCurrentData^.curPos[1]  := 1;
                              eCurrentData^.curReal[1] := 1;
                              if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                              end;
                             eShowStatusBar(1);
                             eGoPos;
                            end;
                           end;
    1..255               : eAddData(eInChar[1]);
    0 : begin
         eInChar := eReadKeyboard;
         case ord(eInChar[1]) of
          eRightKey      :  eGoRight;
          eLeftKey       :  eGoLeft;
          eDownKey       :  eGoDown;
          eUpKey         :  eGoUp;
          ePageUpKey     :  eGoPageUp;
          ePageDnKey     :  eGoPageDn;
          eShiftTabKey   :  begin
                            if (eCurrentData^.curPos[1]-8>=1) then
                             begin
                             dec(eCurrentData^.curPos[1],8);
                             dec(eCurrentData^.curReal[1],8);
                             eShowStatusBar(1);
                             if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                             eGoPos;
                             end else
                            if (eCurrentData^.curPos[1]-8<1) then
                             begin
                             eCurrentData^.curPos[1] := 1;
                             if (eCurrentData^.curColStart>1) then
                              begin
                               if (eCurrentData^.curColStart>8) then
                                begin dec(eCurrentData^.curColStart,8);
                                      dec(eCurrentData^.curReal[1],8);
                                end
                              end else eCurrentData^.curReal[1] := 1;
                              eShowStatusBar(1);
                              if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                              eGoPos;
                             end;
                            end;

          eAltDnKey      :  if (eCurrentData^.curStart+eBotPos[eCurrentData^.curRes]<eMaxLines) then
                             begin
                             inc(eCurrentData^.curStart);
                             inc(eCurrentData^.curReal[2]);
                             eShowStatusBar(1);
                             eUpdateScreen;
                             end;
          eAltUpKey      :  if (eCurrentData^.curStart<>1) then
                             begin
                             dec(eCurrentData^.curStart);
                             dec(eCurrentData^.curReal[2]);
                             eShowStatusBar(1);
                             eUpdateScreen;
                             end;
          eDeleteKey     :  eDoDelete;
          eCtrlUpKey     :  eCycleColors(1);
          eCtrlDownKey   :  eCycleColors(2);
          eCtrlLeftKey   :  eCycleColors(3);
          eCtrlRightKey  :  eCycleColors(4);
          eCtrlPgUpKey   :  begin
                            eCurrentData^.curPos[2]  := 1;
                            eCurrentData^.curPos[1]  := 1;
                            eCurrentData^.curReal[1] := 1;
                            eCurrentData^.curReal[2] := 1;
                            eCurrentData^.curStart   := 1;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(1);
                            eGoPos;
                            end;
          eCtrlPgDnKey   :  begin
                            eCurrentData^.curPos[2]  := eBotPos[eCurrentData^.curRes];
                            eCurrentData^.curPos[1]  := 1;
                            eCurrentData^.curReal[1] := 1;
                            eCurrentData^.curReal[2] := eMaxLines;
                            eCurrentData^.curStart   := eMaxLines-(eBotPos[eCurrentData^.curRes]-1);
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(1);
                            eGoPos;
                            end;
          eAltAKey       :  begin
                            if (eCurrentData^.curRes>1) then textMode(3);
                            eDoAttributeSelection(0);
                            if (eCurrentData^.curRes>1) then eSetResolution;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(6);
                            eGoPos;
                            end;
          eAltBKey       :  eDoBlockFunctions;
          eAltGKey       :  begin
                            eDoGlobalBlockFunctions;
                            eShowStatusBar(6);
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eGoPos;
                            end;
          eAltCKey       :  eCheckClear;
          eAltIKey       :  eDoLineInsert(true);
          eAltYKey       :  eDoLineInsert(false);
          eAltOKey       :  begin
                            eMainConfigEditor;
                            eSetAdfAll;
                            eUpdateScreen;
                            eShowStatusBar(6);
                            eGoPos;
                            end;
          eAltLeftKey    :  eDoColumnInsert(false);
          eAltRightKey   :  eDoColumnInsert(true);
          eAltFKey       :  begin
                            eAdfFontEditor;
                            eUpdateScreen;
                            eShowStatusBar(6);
                            eGoPos;
                            end;
          eAltTKey       :  begin
                            eSelectPage;
                            eUpdateScreen;
                            eLoadSet(eCurrentData^.curSet);
                            eShowStatusBar(6);
                            eGoPos;
                            end;
          eAltUKey       :  begin
                            eGrabCursorAttribute;
                            eShowStatusBar(6);
                            end;
          eAltPKey       :  begin
                            eAdfPaletteEditor;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eGoPos;
                            end;
          eAltDKey       :  begin
                            if (eConfigData^.cRestore=true) then eCheckDefault else
                            eDefaultAdfData;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(6);
                            eGoPos;
                            end;
          eAltNKey       :  if (eCurrentData^.curDragOn=false) then
                            begin
                            eCurrentData^.curRulerOn := not eCurrentData^.curRulerOn;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eGoPos;
                            end else
                             begin
                             eErrorPause('You must disable DragAtr mode to use ruler');
                             eShowStatusBar(6);
                             eGoPos;
                             end;
{ do not adjust resolution if in xbin editing mode }
          eAltMKey       :  If eCurrentData^.CurXBIN Then Begin
                              eErrorPause('You cannot edit XBIN screens in 50 line mode');
                              eShowStatusBar(6);
                              eGoPos;
                            End Else Begin
                            if (eCurrentData^.curRes=1) then inc(eCurrentData^.curRes) else
                            eCurrentData^.curRes := 1;
                            eCurrentData^.curPos[1]  := 1;
                            eCurrentData^.curPos[2]  := 1;
                            eCurrentData^.curReal[1] := 1;
                            eCurrentData^.curReal[2] := 1;
                            eCurrentData^.curStart   := 1;
                            eCurrentData^.curColStart:= 1;
                            eSetResolution;
                            eShowStatusBar(6);
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eGoPos;
                            end;
          eAltVKey       :  begin
                            eViewImageVga(eConfigData^.cWidth*2,eCurrentData^.curLength,eConfigData^.cVgaMode,eXmsHandle);
                            eSetResolution;
                            if (eCurrentData^.curRes=1) then eSetAdfAll;
                            eShowStatusBar(6);
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eGoPos;
                            end;
          eHomeKey       :  begin
                            eCurrentData^.curPos[1]  := 1;
                            eCurrentData^.curReal[1] := eCurrentData^.curColStart;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(1);
                            eGoPos;
                            end;
          eEndKey        :  begin
                            eCurrentData^.curPos[1]  := 80;
                            eCurrentData^.curReal[1] := eCurrentData^.curColStart+79;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(1);
                            eGoPos;
                            end;
          eInsertKey     :  begin
                            eCurrentData^.curInsert := not eCurrentData^.curInsert;
                            eShowStatusBar(3);
                            end;
          eAltKKey       :  begin
                            eCurrentData^.curHidden := not eCurrentData^.curHidden;
                            eShowStatusBar(1);
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eGoPos;
                            end;
          eAltLKey       :  if (eLoadFileMenu=true) then
                             begin
                             eCurrentData^.curPos[1]  := 1;
                             eCurrentData^.curPos[2]  := 1;
                             eCurrentData^.curReal[1] := 1;
                             eCurrentData^.curReal[2] := 1;
                             eCurrentData^.curStart   := 1;
                             eCurrentData^.curColStart:= 1;
                             if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                             eShowStatusBar(6);
                             eGoPos;
                             eReInitTime;
                             end else
                              begin
                              if (eCurrentData^.curRes>1) then eSetResolution;
                              eShowStatusBar(6);
                              if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                              eGoPos;
                              end;
          eAltXKey       :  if eCheckExit then eDone := true else
                            eGoPos;
          eAltSKey       :  begin
                            eSaveMenu;
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eShowStatusBar(6);
                            eGoPos;
                            end;
          eAltJKey       :  begin
                            window(1,1,80,25); asm mov ax, 3; int 10h end;
                            skaWrite('|08 |07Please type (|15EXIT|07) to return to Empathy|CR|07');
                            eDosShell('');
                            eSetAdfAll;
                            eUpdateScreen;
                            eShowStatusBar(6);
                            eGoPos;
                            end;
          eAltHKey       :  ePerformHelp;
          eAltWKey       :  begin
                            eConfigData^.c8x16Mode := not eConfigData^.c8x16Mode;
                            if (eConfigData^.c8x16Mode=false) then
                             begin
                             asm mov ax, 3; int 10h end;
                             eSetAdfAll;
                             eUpdateScreen;
                             eShowStatusBar(6);
                             eGoPos;
                             end else eSetAdfFont;
                            end;
          eAltEKey       :  begin
                            eSauceEditor;
                            eShowStatusBar(6);
                            if (eCurrentData^.curRulerOn=false) then eUpdateScreen;
                            eGoPos;
                            end;
          eAltDragKey    :  if (eCurrentData^.curRulerOn=false) then
                            begin
                            eCurrentData^.curDragOn := not eCurrentData^.curDragOn;
                            eShowStatusBar(2);
                            eGoPos;
                            end else
                             begin
                             eErrorPause('You must disable ruler mode to use DragAtr mode');
                             eShowStatusBar(6);
                             eGoPos;
                             end;
          eFuncKeys..68  :  begin
                            eAddData(eCurrentSet[ord(eInChar[1])-58]);
                            end;
          eAltFKeys..113 :  begin
                            eLoadSet(ord(eInChar[1])-103);
                            eShowStatusBar(5);
                            eGoPos;
                            end;
         eCtrlFKeys..103 :  begin
                            eLoadSet(ord(eInChar[1])-83);
                            eShowStatusBar(5);
                            eGoPos;
                            end;
         eAlt1Key..129   :  begin
                            if (ord(eInChar[1])-119=10) then eSwitchPages(0) else
                             eSwitchPages(ord(eInChar[1])-119);
                            eUpdateScreen;
                            eLoadSet(eCurrentData^.curSet);
                            eShowStatusBar(6);
                            eGoPos;
                            end;
         eAltQKey        : begin
                           eSetNewImageEnd;
                           eUpdateScreen;
                           eShowStatusBar(6);
                           eGoPos;
                           end;
         eAltRKey        : begin
                           eResourceManager;
                           eUpdateScreen;
                           eShowStatusBar(6);
                           eGoPos;
                           end;
         end;
      end;
     end;
    end;
  until (eDone=true);
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eInitProc;
var eCount         : byte;
    eParamFileName : string;
    eInStr         : string[4];
 begin
 if (eValidTestVer=false) then eDrawScreens(5);  { resLib checking }
 eXmsHandle := 0;
 if (upperCase(paramStr(1))='/?') then eDrawScreens(4);
 textAttr := 7;
 eMaxXmsBlock := XMSLargestBlockAvailable;
 eXmsHandle := xmsAllocateBlock(eMaxXmsBlock);
 if ((eXmsHandle=0) or (eMaxXmsBlock=0)) then eDrawScreens(3);
 new(eCurrentData);
 new(eConfigData);
 new(eBlockData);
 eHideMouse;
 eConfineMouse(1,1,3,3);
 eSetMouseSpeed(0,0);
 fillChar(eCurrentData^,sizeOf(eCurrentData^),0);
 eBlockData^.bInTransfer   := false;
 eCurrentData^.curStart    := 1;
 eCurrentData^.curPos[1]   := 1;
 eCurrentData^.curPos[2]   := 1;
 eCurrentData^.curPage     := 0;
 eCurrentData^.curReal[1]  := 1;
 eCurrentData^.curReal[2]  := 1;
 eCurrentData^.curColStart := 1;
 eCurrentData^.curRes      := 1;
 eCurrentData^.curChanges  := 0;
 eCurrentData^.curDragOn   := false;
 eCurrentData^.curSet      := 6;
 eCurrentData^.curIceOn    := true;
 eCurrentData^.curFontNum  := 0;
 eCheckConfig;
 eCurrentData^.curColor   := eConfigData^.cStartBg*16+eConfigData^.cStartFg;
 if eConfigData^.c8x16mode then set8x16Font;
 cursor_off;
 eClearMouse;
 eDefaultAdfData;
 eMaxLines := (eMaxXmsBlock*1000) div (eConfigData^.cWidth*2);
 {if (eConfigData^.cIntro=true) then }eDrawScreens(0);
{ if (eConfigData^.cIntro=true) then
  center_write('total of ('+comma(eMaxLines)+') lines allocated with ('+comma(eConfigData^.cWidth)+') columns each',25);}
{ if (eConfigData^.cIntro=true) then
  begin}
  repeat eInStr := eReadKey
   until (((eMouseUsed=false) and (eInStr<>'none')) or ((eInStr[1] in ['B','Q']) and (eMouseUsed=true)));
  if not eMouseUsed then while keyPressed do readKey else eMouseUsed := false;
 { end; }
 eClearMouse;
 eSetMouseSpeed(5,0);
 cursor_off;
 eCurrentData^.curLength := eMaxLines;
 eClearXms;
 eCurrentData^.curLength := 0;
 eLoadSet(6);
 eDefaultAdfData;
 eSetResolution;
 if (paramCount>0) then
  begin
  eParamFileName := '';
  for eCount := 1 to paramCount do
   if (upperCase(paramStr(eCount))='/L') then eParamFileName := paramStr(eCount+1);
  if (eParamFileName<>'') and exist(eParamFileName) then eLoadFile(eParamFileName);
  end;
 eDrawScreens(1);
 eInitializeTimer;
 eReInitTime;
 eResetSauceData;
 { alter this for timer mode! - stuck down here for accuracy }
 eCurrentData^.curTime.eStarted := true;
 eCurrentData^.curTime.eStart   := eReadTimer;
 end;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Procedure eTermProc;
Begin
  xmsReleaseBlock(eXmsHandle);
  eKillAllPageFiles;
  ChDir(eStartDir + '.');
  TextMode(3);
  eUpdateTimer;
  eDrawScreens(2);
  eRestoreTimer;
  Dispose (eCurrentData);
  Dispose (eConfigData);
  Dispose (eBlockData);
End;

{:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::}

Begin
  eInitProc;
  eScreenEditor;
  eTermProc;
End.